
import { useState,  useEffect } from 'react';

import Request, {YWRequestConfig} from '@ywfe/request';
// @ts-ignore
import * as querystring from 'querystring';
// @ts-ignore
import { ParsedUrlQueryInput } from 'querystring';
// @ts-ignore
import * as R from 'ramda';
import {configs} from './config';


  const projectId = "PROAUTH";
  let env;
  if(typeof window === 'undefined'){
    env = (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  } else {
    env = window.localStorage.getItem('env') || (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  }
  
  const basePath = configs[projectId] ? configs[projectId][env].API_BASE_URL + `${env === 'mock' ? '/' + 88 : ''}` : '';
  const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
  

  

// @ts-ignore




export interface DesktopHomeCommonFunctionAddInput {
  
    
    /** 排序资源 ,String */
    resourceIdList?: any[];
  
}

export interface DesktopHomeCommonFunctionAddData {
  
}


const reduceParams = (data: R.Dictionary<DesktopHomeCommonFunctionAddInput>) => {
  if(data instanceof FormData){
    return data;
  }
  const result = R.filter(item => !R.isNil(item) && !R.isEmpty(item))(data) || {};
  return result as unknown as DesktopHomeCommonFunctionAddInput;
}


// 20949 增加常用功能

  export const usePostDesktopHomeCommonFunctionAdd = () => {
    let isMount = true;
    const [isDesktopHomeCommonFunctionAddLoading, setIsDesktopHomeCommonFunctionAddLoading] = useState(false);
    const [dataDesktopHomeCommonFunctionAdd, setDataDesktopHomeCommonFunctionAdd] = useState<DesktopHomeCommonFunctionAddData>({} as DesktopHomeCommonFunctionAddData);
    const postDesktopHomeCommonFunctionAddData = async(inputs: DesktopHomeCommonFunctionAddInput, config?: YWRequestConfig): Promise<DesktopHomeCommonFunctionAddData> => {
      
        const params = reduceParams(inputs as unknown as R.Dictionary<DesktopHomeCommonFunctionAddInput>) || {};
      
      if(isMount){
        setIsDesktopHomeCommonFunctionAddLoading(true);
      }
      
      try{
        
          
          
          const res: any = await Request.post<DesktopHomeCommonFunctionAddData>(`${basePath}/desktop/home/common/function/add`, params, {
            loginHost: loginPath,
            ...config
          });
          
          
          if(isMount){
            setDataDesktopHomeCommonFunctionAdd(res || {});
            setIsDesktopHomeCommonFunctionAddLoading(false);
          }
          return res;
      } catch(error){
        console.log(error);
        if(isMount){
          setIsDesktopHomeCommonFunctionAddLoading(false);
        }
        return false as unknown as DesktopHomeCommonFunctionAddData;
      }
      
    }

    useEffect(() => {
      return () => {
        isMount = false;
      };
    }, []);
  
    return {
      isDesktopHomeCommonFunctionAddLoading,
      dataDesktopHomeCommonFunctionAdd,
      postDesktopHomeCommonFunctionAddData,
    }
  }

